]> git.ipfire.org Git - ipfire-2.x.git/blob - make.sh
make.sh: Cleanup code that builds ${SYSTEM_RELEASE}
[ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007-2019 IPFire Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 # If you update the version don't forget to update backupiso and add it to core update
28 VERSION="2.25" # Version number
29 CORE="142" # Core Level (Filename)
30 PAKFIRE_CORE="141" # Core Level (PAKFIRE)
31 SLOGAN="www.ipfire.org" # Software slogan
32 CONFIG_ROOT=/var/ipfire # Configuration rootdir
33 NICE=10 # Nice level
34 MAX_RETRIES=1 # prefetch/check loop
35 BUILD_IMAGES=1 # Flash and Xen Downloader
36 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
37
38 # Information from Git
39 GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
40 GIT_TAG="$(git tag | tail -1)" # Git Tag
41 GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
42
43 TOOLCHAINVER=20200108
44
45 ###############################################################################
46 #
47 # Beautifying variables & presentation & input output interface
48 #
49 ###############################################################################
50
51 # Remember if the shell is interactive or not
52 if [ -t 0 ] && [ -t 1 ]; then
53 INTERACTIVE=true
54 else
55 INTERACTIVE=false
56 fi
57
58 # Sets or adjusts pretty formatting variables
59 resize_terminal() {
60 ## Screen Dimentions
61 # Find current screen size
62 COLUMNS=$(tput cols)
63
64 # When using remote connections, such as a serial port, stty size returns 0
65 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
66 COLUMNS=80
67 fi
68
69 # Measurements for positioning result messages
70 OPTIONS_WIDTH=20
71 TIME_WIDTH=12
72 STATUS_WIDTH=8
73 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
74 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
75
76 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
77 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
78 }
79
80 # Initially setup terminal
81 resize_terminal
82
83 # Call resize_terminal when terminal is being resized
84 trap "resize_terminal" WINCH
85
86 # Define color for messages
87 BOLD="\\033[1;39m"
88 DONE="\\033[1;32m"
89 SKIP="\\033[1;34m"
90 WARN="\\033[1;35m"
91 FAIL="\\033[1;31m"
92 NORMAL="\\033[0;39m"
93
94 # New architecture variables
95 HOST_ARCH="$(uname -m)"
96
97 PWD=$(pwd)
98 BASENAME=$(basename $0)
99
100 # Debian specific settings
101 if [ ! -e /etc/debian_version ]; then
102 FULLPATH=`which $0`
103 else
104 if [ -x /usr/bin/realpath ]; then
105 FULLPATH=`/usr/bin/realpath $0`
106 else
107 echo "ERROR: Need to do apt-get install realpath"
108 exit 1
109 fi
110 fi
111
112 # This is the directory where make.sh is in
113 export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
114
115 LOGFILE=$BASEDIR/log/_build.preparation.log
116 export LOGFILE
117 DIR_CHK=$BASEDIR/cache/check
118 mkdir $BASEDIR/log/ 2>/dev/null
119
120 system_processors() {
121 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
122 }
123
124 system_memory() {
125 local key val unit
126
127 while read -r key val unit; do
128 case "${key}" in
129 MemTotal:*)
130 # Convert to MB
131 echo "$(( ${val} / 1024 ))"
132 break
133 ;;
134 esac
135 done < /proc/meminfo
136 }
137
138 configure_build() {
139 local build_arch="${1}"
140
141 if [ "${build_arch}" = "default" ]; then
142 build_arch="$(configure_build_guess)"
143 fi
144
145 case "${build_arch}" in
146 x86_64)
147 BUILDTARGET="${build_arch}-unknown-linux-gnu"
148 CROSSTARGET="${build_arch}-cross-linux-gnu"
149 BUILD_PLATFORM="x86"
150 CFLAGS_ARCH="-m64 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic"
151 ;;
152
153 i586)
154 BUILDTARGET="${build_arch}-pc-linux-gnu"
155 CROSSTARGET="${build_arch}-cross-linux-gnu"
156 BUILD_PLATFORM="x86"
157 CFLAGS_ARCH="-march=i586 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic -fomit-frame-pointer"
158 ;;
159
160 aarch64)
161 BUILDTARGET="${build_arch}-unknown-linux-gnu"
162 CROSSTARGET="${build_arch}-cross-linux-gnu"
163 BUILD_PLATFORM="arm"
164 CFLAGS_ARCH=""
165 ;;
166
167 armv7hl)
168 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
169 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
170 BUILD_PLATFORM="arm"
171 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
172 ;;
173
174 armv5tel)
175 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
176 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
177 BUILD_PLATFORM="arm"
178 CFLAGS_ARCH="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
179 RUSTFLAGS="-Ccodegen-units=1"
180 ;;
181
182 *)
183 exiterror "Cannot build for architure ${build_arch}"
184 ;;
185 esac
186
187 # Check if the QEMU helper is available if needed.
188 if qemu_is_required "${build_arch}"; then
189 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
190
191 if [ -n "${qemu_build_helper}" ]; then
192 QEMU_TARGET_HELPER="${qemu_build_helper}"
193 else
194 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
195 fi
196 fi
197
198 BUILD_ARCH="${build_arch}"
199 TOOLS_DIR="/tools_${BUILD_ARCH}"
200
201 # Enables hardening
202 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
203
204 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
205 CXXFLAGS="${CFLAGS}"
206
207 # Determine parallelism
208 # We assume that each process consumes about
209 # 128MB of memory. Therefore we find out how
210 # many processes fit into memory.
211 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
212 local cpu_max=$(( ${SYSTEM_PROCESSORS} + 1 ))
213
214 local parallelism
215 if [ ${mem_max} -lt ${cpu_max} ]; then
216 parallelism=${mem_max}
217 else
218 parallelism=${cpu_max}
219 fi
220
221 # Use this as default PARALLELISM
222 DEFAULT_PARALLELISM="${parallelism}"
223
224 # Compression parameters
225 # We use mode 8 for reasonable memory usage when decompressing
226 # but with overall good compression
227 XZ_OPT="-8"
228
229 # We try to use as many cores as possible
230 XZ_OPT="${XZ_OPT} -T0"
231
232 # We need to limit memory because XZ uses too much when running
233 # in parallel and it isn't very smart in limiting itself.
234 # We allow XZ to use up to 70% of all system memory.
235 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
236
237 # XZ memory cannot be larger than 2GB on 32 bit systems
238 case "${build_arch}" in
239 i*86|armv*)
240 if [ ${xz_memory} -gt 2048 ]; then
241 xz_memory=2048
242 fi
243 ;;
244 esac
245
246 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
247 }
248
249 configure_build_guess() {
250 case "${HOST_ARCH}" in
251 x86_64)
252 echo "x86_64"
253 ;;
254 i?86)
255 echo "i586"
256 ;;
257
258 aarch64)
259 echo "aarch64"
260 ;;
261
262 armv7*|armv6*|armv5*)
263 echo "armv5tel"
264 ;;
265
266 *)
267 exiterror "Cannot guess build architecture"
268 ;;
269 esac
270 }
271
272 stdumount() {
273 umount $BASEDIR/build/sys 2>/dev/null;
274 umount $BASEDIR/build/dev/shm 2>/dev/null;
275 umount $BASEDIR/build/dev/pts 2>/dev/null;
276 umount $BASEDIR/build/dev 2>/dev/null;
277 umount $BASEDIR/build/proc 2>/dev/null;
278 umount $BASEDIR/build/install/mnt 2>/dev/null;
279 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
280 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
281 umount $BASEDIR/build/usr/src/config 2>/dev/null;
282 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
283 umount $BASEDIR/build/usr/src/html 2>/dev/null;
284 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
285 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
286 umount $BASEDIR/build/usr/src/log 2>/dev/null;
287 umount $BASEDIR/build/usr/src/src 2>/dev/null;
288 umount $BASEDIR/build/usr/src 2>/dev/null;
289 }
290
291 now() {
292 date -u "+%s"
293 }
294
295 format_runtime() {
296 local seconds=${1}
297
298 if [ ${seconds} -ge 3600 ]; then
299 printf "%d:%02d:%02d\n" \
300 "$(( seconds / 3600 ))" \
301 "$(( seconds % 3600 / 60 ))" \
302 "$(( seconds % 3600 % 60 ))"
303 elif [ ${seconds} -ge 60 ]; then
304 printf "%d:%02d\n" \
305 "$(( seconds / 60 ))" \
306 "$(( seconds % 60 ))"
307 else
308 printf "%d\n" "${seconds}"
309 fi
310 }
311
312 print_line() {
313 local line="$@"
314
315 printf "%-${LINE_WIDTH}s" "${line}"
316 }
317
318 _print_line() {
319 local status="${1}"
320 shift
321
322 if ${INTERACTIVE}; then
323 printf "${!status}"
324 fi
325
326 print_line "$@"
327
328 if ${INTERACTIVE}; then
329 printf "${NORMAL}"
330 fi
331 }
332
333 print_headline() {
334 _print_line BOLD "$@"
335 }
336
337 print_error() {
338 _print_line FAIL "$@"
339 }
340
341 print_package() {
342 local name="${1}"
343 shift
344
345 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
346 local options="$@"
347
348 local string="${name}"
349 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
350 string="${string} (${version})"
351 fi
352
353 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
354 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
355 }
356
357 print_runtime() {
358 local runtime=$(format_runtime $@)
359
360 if ${INTERACTIVE}; then
361 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
362 else
363 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
364 fi
365 }
366
367 print_status() {
368 local status="${1}"
369
370 local color="${!status}"
371
372 if ${INTERACTIVE}; then
373 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
374 else
375 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
376 fi
377 }
378
379 print_build_stage() {
380 print_headline "$@"
381
382 # end line
383 printf "\n"
384 }
385
386 print_build_summary() {
387 local runtime=$(format_runtime $@)
388
389 print_line "*** Build finished in ${runtime}"
390 print_status DONE
391 }
392
393 exiterror() {
394 stdumount
395 for i in `seq 0 7`; do
396 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
397 losetup -d /dev/loop${i} 2>/dev/null
398 fi;
399 done
400
401 # Dump logfile
402 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
403 echo # empty line
404
405 local line
406 while read -r line; do
407 echo " ${line}"
408 done <<< "$(tail -n30 ${LOGFILE})"
409 fi
410
411 echo # empty line
412
413 local line
414 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
415 print_error "${line}"
416 print_status FAIL
417 done
418
419 exit 1
420 }
421
422 prepareenv() {
423 # Are we running the right shell?
424 if [ -z "${BASH}" ]; then
425 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
426 fi
427
428 if [ -z "${BASH_VERSION}" ]; then
429 exiterror "Not running BASH shell."
430 fi
431
432 # Trap on emergency exit
433 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
434
435 # Resetting our nice level
436 if ! renice ${NICE} $$ >/dev/null; then
437 exiterror "Failed to set nice level to ${NICE}"
438 fi
439
440 # Checking if running as root user
441 if [ $(id -u) -ne 0 ]; then
442 exiterror "root privileges required for building"
443 fi
444
445 # Checking for necessary temporary space
446 print_line "Checking for necessary space on disk $BASE_DEV"
447 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
448 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
449 if (( 2048000 > $BASE_ASPACE )); then
450 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
451 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
452 print_status FAIL
453 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
454 fi
455 else
456 print_status DONE
457 fi
458
459 # Set umask
460 umask 022
461
462 # Set LFS Directory
463 LFS=$BASEDIR/build
464
465 # Setup environment
466 set +h
467 LC_ALL=POSIX
468 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS
469 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
470
471 # Make some extra directories
472 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
473 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
474 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
475 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}} 2>/dev/null
476
477 if [ "${ENABLE_RAMDISK}" = "on" ]; then
478 mkdir -p $BASEDIR/build/usr/src
479 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
480 fi
481
482 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
483
484 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
485 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
486
487 # Make all sources and proc available under lfs build
488 mount --bind /dev $BASEDIR/build/dev
489 mount --bind /dev/pts $BASEDIR/build/dev/pts
490 mount --bind /dev/shm $BASEDIR/build/dev/shm
491 mount --bind /proc $BASEDIR/build/proc
492 mount --bind /sys $BASEDIR/build/sys
493 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
494 mount --bind $BASEDIR/ccache/${BUILD_ARCH} $BASEDIR/build/usr/src/ccache
495 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
496 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
497 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
498 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
499 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
500 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
501 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
502
503 # Run LFS static binary creation scripts one by one
504 export CCACHE_DIR=$BASEDIR/ccache
505 export CCACHE_COMPRESS=1
506 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
507
508 # Remove pre-install list of installed files in case user erase some files before rebuild
509 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
510
511 # Prepare string for /etc/system-release.
512 local system_release="${NAME} ${VERSION} (${BUILD_ARCH})"
513
514 case "${GIT_BRANCH}" in
515 core*|beta?|rc?)
516 system_release="${system_release} - ${GIT_BRANCH}"
517 ;;
518 *)
519 system_release="${system_release} - Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
520 ;;
521 esac
522
523 # Append -dirty tag for local changes
524 if [ "$(git status -s | wc -l)" != "0" ]; then
525 system_release="${system_release}-dirty"
526 fi
527
528 # Export variable
529 SYSTEM_RELEASE="${system_release}"
530
531 # Setup ccache cache size
532 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}" >/dev/null
533 }
534
535 enterchroot() {
536 # Install QEMU helper, if needed
537 qemu_install_helper
538
539 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
540
541 PATH="${PATH}" chroot ${LFS} env -i \
542 HOME="/root" \
543 TERM="${TERM}" \
544 PS1="${PS1}" \
545 PATH="${PATH}" \
546 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
547 PAKFIRE_CORE="${PAKFIRE_CORE}" \
548 NAME="${NAME}" \
549 SNAME="${SNAME}" \
550 VERSION="${VERSION}" \
551 CORE="${CORE}" \
552 SLOGAN="${SLOGAN}" \
553 TOOLS_DIR="${TOOLS_DIR}" \
554 CONFIG_ROOT="${CONFIG_ROOT}" \
555 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
556 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
557 RUSTFLAGS="${RUSTFLAGS}" \
558 BUILDTARGET="${BUILDTARGET}" \
559 CROSSTARGET="${CROSSTARGET}" \
560 BUILD_ARCH="${BUILD_ARCH}" \
561 BUILD_PLATFORM="${BUILD_PLATFORM}" \
562 CCACHE_DIR=/usr/src/ccache \
563 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
564 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
565 GOCACHE="/usr/src/ccache/go" \
566 KVER="${KVER}" \
567 XZ_OPT="${XZ_OPT}" \
568 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
569 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
570 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
571 $(fake_environ) \
572 $(qemu_environ) \
573 "$@"
574 }
575
576 entershell() {
577 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
578 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
579 fi
580
581 echo "Entering to a shell inside LFS chroot, go out with exit"
582 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
583
584 if enterchroot bash -i; then
585 stdumount
586 else
587 print_status FAIL
588 exiterror "chroot error"
589 fi
590 }
591
592 lfsmakecommoncheck() {
593 # Script present?
594 if [ ! -f $BASEDIR/lfs/$1 ]; then
595 exiterror "No such file or directory: $BASEDIR/$1"
596 fi
597
598 # Print package name and version
599 print_package $@
600
601 # Check if this package is supported by our architecture.
602 # If no SUP_ARCH is found, we assume the package can be built for all.
603 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
604 # Check if package supports ${BUILD_ARCH} or all architectures.
605 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
606 print_runtime 0
607 print_status SKIP
608 return 1
609 fi
610 fi
611
612 # Script slipped?
613 local i
614 for i in $SKIP_PACKAGE_LIST
615 do
616 if [ "$i" == "$1" ]; then
617 print_status SKIP
618 return 1;
619 fi
620 done
621
622 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
623
624 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
625 MESSAGE="$1\t " download >> $LOGFILE 2>&1
626 if [ $? -ne 0 ]; then
627 exiterror "Download error in $1"
628 fi
629
630 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
631 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
632 if [ $? -ne 0 ]; then
633 exiterror "md5sum error in $1, check file in cache or signature"
634 fi
635
636 return 0 # pass all!
637 }
638
639 lfsmake1() {
640 lfsmakecommoncheck $*
641 [ $? == 1 ] && return 0
642
643 cd $BASEDIR/lfs && env -i \
644 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
645 CCACHE_DIR="${CCACHE_DIR}" \
646 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
647 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
648 CFLAGS="${CFLAGS}" \
649 CXXFLAGS="${CXXFLAGS}" \
650 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
651 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
652 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
653 make -f $* \
654 TOOLCHAIN=1 \
655 TOOLS_DIR="${TOOLS_DIR}" \
656 CROSSTARGET="${CROSSTARGET}" \
657 BUILDTARGET="${BUILDTARGET}" \
658 BUILD_ARCH="${BUILD_ARCH}" \
659 BUILD_PLATFORM="${BUILD_PLATFORM}" \
660 LFS_BASEDIR="${BASEDIR}" \
661 ROOT="${LFS}" \
662 KVER="${KVER}" \
663 install >> $LOGFILE 2>&1 &
664
665 if ! wait_until_finished $!; then
666 print_status FAIL
667 exiterror "Building $*"
668 fi
669
670 print_status DONE
671 }
672
673 lfsmake2() {
674 lfsmakecommoncheck $*
675 [ $? == 1 ] && return 0
676
677 local PS1='\u:\w$ '
678
679 enterchroot \
680 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
681 make -f $* \
682 LFS_BASEDIR=/usr/src install" \
683 >> ${LOGFILE} 2>&1 &
684
685 if ! wait_until_finished $!; then
686 print_status FAIL
687 exiterror "Building $*"
688 fi
689
690 print_status DONE
691 }
692
693 ipfiredist() {
694 lfsmakecommoncheck $*
695 [ $? == 1 ] && return 0
696
697 local PS1='\u:\w$ '
698
699 enterchroot \
700 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
701 >> ${LOGFILE} 2>&1 &
702
703 if ! wait_until_finished $!; then
704 print_status FAIL
705 exiterror "Packaging $*"
706 fi
707
708 print_status DONE
709 }
710
711 wait_until_finished() {
712 local pid=${1}
713
714 local start_time=$(now)
715
716 # Show progress
717 if ${INTERACTIVE}; then
718 # Wait a little just in case the process
719 # has finished very quickly.
720 sleep 0.1
721
722 local runtime
723 while kill -0 ${pid} 2>/dev/null; do
724 print_runtime $(( $(now) - ${start_time} ))
725
726 # Wait a little
727 sleep 1
728 done
729 fi
730
731 # Returns the exit code of the child process
732 wait ${pid}
733 local ret=$?
734
735 if ! ${INTERACTIVE}; then
736 print_runtime $(( $(now) - ${start_time} ))
737 fi
738
739 return ${ret}
740 }
741
742 fake_environ() {
743 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
744
745 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
746
747 # Fake kernel version, because some of the packages do not compile
748 # with kernel 3.0 and later.
749 env="${env} UTS_RELEASE=${KVER}-ipfire"
750
751 # Fake machine version.
752 env="${env} UTS_MACHINE=${BUILD_ARCH}"
753
754 echo "${env}"
755 }
756
757 qemu_environ() {
758 local env
759
760 # Don't add anything if qemu is not used.
761 if ! qemu_is_required; then
762 return
763 fi
764
765 # Set default qemu options
766 case "${BUILD_ARCH}" in
767 arm*)
768 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
769
770 env="${env} QEMU_CPU=${QEMU_CPU}"
771 ;;
772 esac
773
774 # Enable QEMU strace
775 #env="${env} QEMU_STRACE=1"
776
777 echo "${env}"
778 }
779
780 qemu_is_required() {
781 local build_arch="${1}"
782
783 if [ -z "${build_arch}" ]; then
784 build_arch="${BUILD_ARCH}"
785 fi
786
787 case "${HOST_ARCH},${build_arch}" in
788 x86_64,arm*|i?86,arm*|i?86,x86_64)
789 return 0
790 ;;
791 *)
792 return 1
793 ;;
794 esac
795 }
796
797 qemu_install_helper() {
798 # Do nothing, if qemu is not required
799 if ! qemu_is_required; then
800 return 0
801 fi
802
803 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
804 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
805 fi
806
807 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
808 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
809 fi
810
811
812 if [ -z "${QEMU_TARGET_HELPER}" ]; then
813 exiterror "QEMU_TARGET_HELPER not set"
814 fi
815
816 # Check if the helper is already installed.
817 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
818 return 0
819 fi
820
821 # Try to find a suitable binary that we can install
822 # to the build environment.
823 local file
824 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
825 # file must exist and be executable.
826 [ -x "${file}" ] || continue
827
828 # Must be static.
829 file_is_static "${file}" || continue
830
831 local dirname="${LFS}$(dirname "${file}")"
832 mkdir -p "${dirname}"
833
834 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
835 return 0
836 done
837
838 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
839 }
840
841 qemu_find_build_helper_name() {
842 local build_arch="${1}"
843
844 local magic
845 case "${build_arch}" in
846 arm*)
847 magic="7f454c4601010100000000000000000002002800"
848 ;;
849 x86_64)
850 magic="7f454c4602010100000000000000000002003e00"
851 ;;
852 esac
853
854 [ -z "${magic}" ] && return 1
855
856 local file
857 for file in /proc/sys/fs/binfmt_misc/*; do
858 # skip write only register entry
859 [ $(basename "${file}") = "register" ] && continue
860 # Search for the file with the correct magic value.
861 grep -qE "^magic ${magic}$" "${file}" || continue
862
863 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
864
865 [ -n "${interpreter}" ] || continue
866 [ "${interpreter:0:1}" = "/" ] || continue
867 [ -x "${interpreter}" ] || continue
868
869 echo "${interpreter}"
870 return 0
871 done
872
873 return 1
874 }
875
876 file_is_static() {
877 local file="${1}"
878
879 file ${file} 2>/dev/null | grep -q "statically linked"
880 }
881
882 update_language_list() {
883 local path="${1}"
884
885 local lang
886 for lang in ${path}/*.po; do
887 lang="$(basename "${lang}")"
888 echo "${lang%*.po}"
889 done | sort -u > "${path}/LINGUAS"
890 }
891
892 contributors() {
893 local commits name
894
895 git shortlog --summary --numbered | while read -r commits name; do
896 echo "${name}"
897 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
898 }
899
900 update_contributors() {
901 echo -n "Updating list of contributors"
902
903 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
904
905 # Edit contributors into credits.cgi
906 local tmp="$(mktemp)"
907
908 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
909 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
910
911 # Copy back modified content
912 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
913 unlink "${tmp}"
914
915 print_status DONE
916 return 0
917 }
918
919 # Default settings
920 CCACHE_CACHE_SIZE="4G"
921 ENABLE_RAMDISK="auto"
922
923 # Load configuration file
924 if [ -f .config ]; then
925 . .config
926 fi
927
928 # TARGET_ARCH is BUILD_ARCH now
929 if [ -n "${TARGET_ARCH}" ]; then
930 BUILD_ARCH="${TARGET_ARCH}"
931 unset TARGET_ARCH
932 fi
933
934 # Get some information about the host system
935 SYSTEM_PROCESSORS="$(system_processors)"
936 SYSTEM_MEMORY="$(system_memory)"
937
938 if [ -n "${BUILD_ARCH}" ]; then
939 configure_build "${BUILD_ARCH}"
940 else
941 configure_build "default"
942 fi
943
944 # Automatically enable/disable ramdisk usage
945 if [ "${ENABLE_RAMDISK}" = "auto" ]; then
946 # Enable only when the host system has 4GB of RAM or more
947 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
948 ENABLE_RAMDISK="on"
949 fi
950 fi
951
952 buildtoolchain() {
953 local error=false
954 case "${BUILD_ARCH}:${HOST_ARCH}" in
955 # x86_64
956 x86_64:x86_64)
957 # This is working.
958 ;;
959
960 # x86
961 i586:i586|i586:i686|i586:x86_64)
962 # These are working.
963 ;;
964 i586:*)
965 error=true
966 ;;
967
968 # ARM
969 arvm7hl:armv7hl|armv7hl:armv7l)
970 # These are working.
971 ;;
972
973 armv5tel:armv5tel|armv5tel:armv5tejl|armv5tel:armv6l|armv5tel:armv7l|armv5tel:aarch64)
974 # These are working.
975 ;;
976 armv5tel:*)
977 error=true
978 ;;
979 esac
980
981 ${error} && \
982 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
983
984 local gcc=$(type -p gcc)
985 if [ -z "${gcc}" ]; then
986 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
987 fi
988
989 # Check ${TOOLS_DIR} symlink
990 if [ -h "${TOOLS_DIR}" ]; then
991 rm -f "${TOOLS_DIR}"
992 fi
993
994 if [ ! -e "${TOOLS_DIR}" ]; then
995 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
996 fi
997
998 if [ ! -h "${TOOLS_DIR}" ]; then
999 exiterror "Could not create ${TOOLS_DIR} symbolic link"
1000 fi
1001
1002 LOGFILE="$BASEDIR/log/_build.toolchain.log"
1003 export LOGFILE
1004
1005 lfsmake1 stage1
1006 lfsmake1 ccache PASS=1
1007 lfsmake1 binutils PASS=1
1008 lfsmake1 gcc PASS=1
1009 lfsmake1 linux KCFG="-headers"
1010 lfsmake1 glibc
1011 lfsmake1 gcc PASS=L
1012 lfsmake1 binutils PASS=2
1013 lfsmake1 gcc PASS=2
1014 lfsmake1 zlib
1015 lfsmake1 ccache PASS=2
1016 lfsmake1 tcl
1017 lfsmake1 expect
1018 lfsmake1 dejagnu
1019 lfsmake1 pkg-config
1020 lfsmake1 ncurses
1021 lfsmake1 bash
1022 lfsmake1 bzip2
1023 lfsmake1 automake
1024 lfsmake1 coreutils
1025 lfsmake1 diffutils
1026 lfsmake1 findutils
1027 lfsmake1 gawk
1028 lfsmake1 gettext
1029 lfsmake1 grep
1030 lfsmake1 gzip
1031 lfsmake1 m4
1032 lfsmake1 make
1033 lfsmake1 patch
1034 lfsmake1 perl
1035 lfsmake1 python3
1036 lfsmake1 sed
1037 lfsmake1 tar
1038 lfsmake1 texinfo
1039 lfsmake1 xz
1040 lfsmake1 bison
1041 lfsmake1 flex
1042 lfsmake1 fake-environ
1043 lfsmake1 strip
1044 lfsmake1 cleanup-toolchain
1045 }
1046
1047 buildbase() {
1048 LOGFILE="$BASEDIR/log/_build.base.log"
1049 export LOGFILE
1050 lfsmake2 stage2
1051 lfsmake2 linux KCFG="-headers"
1052 lfsmake2 man-pages
1053 lfsmake2 glibc
1054 lfsmake2 tzdata
1055 lfsmake2 cleanup-toolchain
1056 lfsmake2 zlib
1057 lfsmake2 binutils
1058 lfsmake2 gmp
1059 lfsmake2 gmp-compat
1060 lfsmake2 mpfr
1061 lfsmake2 libmpc
1062 lfsmake2 file
1063 lfsmake2 gcc
1064 lfsmake2 sed
1065 lfsmake2 autoconf
1066 lfsmake2 automake
1067 lfsmake2 berkeley
1068 lfsmake2 coreutils
1069 lfsmake2 iana-etc
1070 lfsmake2 m4
1071 lfsmake2 bison
1072 lfsmake2 ncurses
1073 lfsmake2 procps
1074 lfsmake2 libtool
1075 lfsmake2 perl
1076 lfsmake2 readline
1077 lfsmake2 readline-compat
1078 lfsmake2 bzip2
1079 lfsmake2 xz
1080 lfsmake2 pcre
1081 lfsmake2 pcre-compat
1082 lfsmake2 bash
1083 lfsmake2 diffutils
1084 lfsmake2 e2fsprogs
1085 lfsmake2 ed
1086 lfsmake2 findutils
1087 lfsmake2 flex
1088 lfsmake2 gawk
1089 lfsmake2 gettext
1090 lfsmake2 grep
1091 lfsmake2 groff
1092 lfsmake2 gperf
1093 lfsmake2 gzip
1094 lfsmake2 hostname
1095 lfsmake2 iproute2
1096 lfsmake2 jwhois
1097 lfsmake2 kbd
1098 lfsmake2 less
1099 lfsmake2 pkg-config
1100 lfsmake2 make
1101 lfsmake2 man
1102 lfsmake2 kmod
1103 lfsmake2 net-tools
1104 lfsmake2 patch
1105 lfsmake2 psmisc
1106 lfsmake2 shadow
1107 lfsmake2 sysklogd
1108 lfsmake2 sysvinit
1109 lfsmake2 tar
1110 lfsmake2 texinfo
1111 lfsmake2 util-linux
1112 lfsmake2 udev
1113 lfsmake2 vim
1114 }
1115
1116 buildipfire() {
1117 LOGFILE="$BASEDIR/log/_build.ipfire.log"
1118 export LOGFILE
1119 lfsmake2 configroot
1120 lfsmake2 initscripts
1121 lfsmake2 backup
1122 lfsmake2 openssl
1123 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG='-sse2'
1124 lfsmake2 popt
1125 lfsmake2 libedit
1126 lfsmake2 libusb
1127 lfsmake2 libusb-compat
1128 lfsmake2 libpcap
1129 lfsmake2 ppp
1130 lfsmake2 pptp
1131 lfsmake2 unzip
1132 lfsmake2 which
1133 lfsmake2 linux-firmware
1134 lfsmake2 dvb-firmwares
1135 lfsmake2 xr819-firmware
1136 lfsmake2 zd1211-firmware
1137 lfsmake2 rpi-firmware
1138 lfsmake2 intel-microcode
1139 lfsmake2 pcengines-apu-firmware
1140 lfsmake2 bc
1141 lfsmake2 u-boot MKIMAGE=1
1142 lfsmake2 cpio
1143 lfsmake2 mdadm
1144 lfsmake2 dracut
1145 lfsmake2 libaio
1146 lfsmake2 lvm2
1147 lfsmake2 multipath-tools
1148 lfsmake2 freetype
1149 lfsmake2 libmnl
1150 lfsmake2 libnfnetlink
1151 lfsmake2 libnetfilter_queue
1152 lfsmake2 libnetfilter_conntrack
1153 lfsmake2 libnetfilter_cthelper
1154 lfsmake2 libnetfilter_cttimeout
1155 lfsmake2 iptables
1156 lfsmake2 screen
1157 lfsmake2 elfutils
1158
1159 case "${BUILD_ARCH}" in
1160 x86_64|aarch64)
1161 lfsmake2 linux KCFG=""
1162 # lfsmake2 backports KCFG=""
1163 # lfsmake2 e1000e KCFG=""
1164 # lfsmake2 igb KCFG=""
1165 # lfsmake2 ixgbe KCFG=""
1166 lfsmake2 xtables-addons KCFG=""
1167 lfsmake2 linux-initrd KCFG=""
1168 ;;
1169 i586)
1170 # x86-pae (Native and new XEN) kernel build
1171 lfsmake2 linux KCFG="-pae"
1172 # lfsmake2 backports KCFG="-pae"
1173 # lfsmake2 e1000e KCFG="-pae"
1174 # lfsmake2 igb KCFG="-pae"
1175 # lfsmake2 ixgbe KCFG="-pae"
1176 lfsmake2 xtables-addons KCFG="-pae"
1177 lfsmake2 linux-initrd KCFG="-pae"
1178
1179 # x86 kernel build
1180 lfsmake2 linux KCFG=""
1181 # lfsmake2 backports KCFG=""
1182 # lfsmake2 e1000e KCFG=""
1183 # lfsmake2 igb KCFG=""
1184 # lfsmake2 ixgbe KCFG=""
1185 lfsmake2 xtables-addons KCFG=""
1186 lfsmake2 linux-initrd KCFG=""
1187 ;;
1188
1189 armv5tel)
1190 # arm multi platform (Panda, Wandboard ...) kernel build
1191 lfsmake2 linux KCFG="-multi"
1192 # lfsmake2 backports KCFG="-multi"
1193 # lfsmake2 e1000e KCFG="-multi"
1194 # lfsmake2 igb KCFG="-multi"
1195 # lfsmake2 ixgbe KCFG="-multi"
1196 lfsmake2 xtables-addons KCFG="-multi"
1197 lfsmake2 linux-initrd KCFG="-multi"
1198 ;;
1199 esac
1200 lfsmake2 xtables-addons USPACE="1"
1201 lfsmake2 libgpg-error
1202 lfsmake2 libgcrypt
1203 lfsmake2 libassuan
1204 lfsmake2 nettle
1205 lfsmake2 json-c
1206 lfsmake2 libconfig
1207 lfsmake2 libevent
1208 lfsmake2 libevent2
1209 lfsmake2 expat
1210 lfsmake2 apr
1211 lfsmake2 aprutil
1212 lfsmake2 unbound
1213 lfsmake2 gnutls
1214 lfsmake2 bind
1215 lfsmake2 dhcp
1216 lfsmake2 dhcpcd
1217 lfsmake2 boost
1218 lfsmake2 linux-atm
1219 lfsmake2 gdbm
1220 lfsmake2 pam
1221 lfsmake2 curl
1222 lfsmake2 tcl
1223 lfsmake2 sqlite
1224 lfsmake2 libffi
1225 lfsmake2 python
1226 lfsmake2 python3
1227 lfsmake2 grub
1228 lfsmake2 efivar
1229 lfsmake2 efibootmgr
1230 lfsmake2 ca-certificates
1231 lfsmake2 fireinfo
1232 lfsmake2 libnet
1233 lfsmake2 libnl
1234 lfsmake2 libnl-3
1235 lfsmake2 libidn
1236 lfsmake2 nasm
1237 lfsmake2 libjpeg
1238 lfsmake2 libjpeg-compat
1239 lfsmake2 libexif
1240 lfsmake2 libpng
1241 lfsmake2 libtiff
1242 lfsmake2 libart
1243 lfsmake2 gd
1244 lfsmake2 slang
1245 lfsmake2 newt
1246 lfsmake2 libsmooth
1247 lfsmake2 attr
1248 lfsmake2 acl
1249 lfsmake2 libcap
1250 lfsmake2 libcap-ng
1251 lfsmake2 pciutils
1252 lfsmake2 usbutils
1253 lfsmake2 libxml2
1254 lfsmake2 libxslt
1255 lfsmake2 BerkeleyDB
1256 lfsmake2 cyrus-sasl
1257 lfsmake2 openldap
1258 lfsmake2 apache2
1259 lfsmake2 web-user-interface
1260 lfsmake2 flag-icons
1261 lfsmake2 jquery
1262 lfsmake2 bootstrap
1263 lfsmake2 arping
1264 lfsmake2 beep
1265 lfsmake2 libarchive
1266 lfsmake2 cmake
1267 lfsmake2 libssh
1268 lfsmake2 cdrkit
1269 lfsmake2 dosfstools
1270 lfsmake2 reiserfsprogs
1271 lfsmake2 xfsprogs
1272 lfsmake2 sysfsutils
1273 lfsmake2 fuse
1274 lfsmake2 ntfs-3g
1275 lfsmake2 ethtool
1276 lfsmake2 ez-ipupdate
1277 lfsmake2 fcron
1278 lfsmake2 perl-GD
1279 lfsmake2 GD-Graph
1280 lfsmake2 GD-TextUtil
1281 lfsmake2 perl-Device-SerialPort
1282 lfsmake2 perl-Device-Modem
1283 lfsmake2 perl-Apache-Htpasswd
1284 lfsmake2 gnupg
1285 lfsmake2 hdparm
1286 lfsmake2 sdparm
1287 lfsmake2 mtools
1288 lfsmake2 whatmask
1289 lfsmake2 conntrack-tools
1290 lfsmake2 libupnp
1291 lfsmake2 ipaddr
1292 lfsmake2 iputils
1293 lfsmake2 l7-protocols
1294 lfsmake2 hwdata
1295 lfsmake2 logrotate
1296 lfsmake2 logwatch
1297 lfsmake2 misc-progs
1298 lfsmake2 nano
1299 lfsmake2 URI
1300 lfsmake2 perl-CGI
1301 lfsmake2 perl-Switch
1302 lfsmake2 HTML-Tagset
1303 lfsmake2 HTML-Parser
1304 lfsmake2 HTML-Template
1305 lfsmake2 Compress-Zlib
1306 lfsmake2 Digest
1307 lfsmake2 Digest-SHA1
1308 lfsmake2 Digest-HMAC
1309 lfsmake2 libwww-perl
1310 lfsmake2 Net-DNS
1311 lfsmake2 Net-IPv4Addr
1312 lfsmake2 Net_SSLeay
1313 lfsmake2 IO-Stringy
1314 lfsmake2 IO-Socket-SSL
1315 lfsmake2 Unix-Syslog
1316 lfsmake2 Mail-Tools
1317 lfsmake2 MIME-Tools
1318 lfsmake2 Net-Server
1319 lfsmake2 Convert-TNEF
1320 lfsmake2 Convert-UUlib
1321 lfsmake2 Archive-Tar
1322 lfsmake2 Archive-Zip
1323 lfsmake2 Text-Tabs+Wrap
1324 lfsmake2 Locale-Country
1325 lfsmake2 XML-Parser
1326 lfsmake2 Crypt-PasswdMD5
1327 lfsmake2 Net-Telnet
1328 lfsmake2 python-setuptools
1329 lfsmake2 python-clientform
1330 lfsmake2 python-mechanize
1331 lfsmake2 python-feedparser
1332 lfsmake2 python-rssdler
1333 lfsmake2 python-inotify
1334 lfsmake2 python-docutils
1335 lfsmake2 python-daemon
1336 lfsmake2 python-ipaddress
1337 lfsmake2 glib
1338 lfsmake2 GeoIP
1339 lfsmake2 geoip-database
1340 lfsmake2 ntp
1341 lfsmake2 openssh
1342 lfsmake2 fontconfig
1343 lfsmake2 dejavu-fonts-ttf
1344 lfsmake2 ubuntu-font-family
1345 lfsmake2 freefont
1346 lfsmake2 pixman
1347 lfsmake2 cairo
1348 lfsmake2 pango
1349 lfsmake2 rrdtool
1350 lfsmake2 setserial
1351 lfsmake2 setup
1352 lfsmake2 libdnet
1353 lfsmake2 rust
1354 lfsmake2 jansson
1355 lfsmake2 yaml
1356 lfsmake2 libhtp
1357 lfsmake2 colm
1358 lfsmake2 ragel
1359 lfsmake2 hyperscan
1360 lfsmake2 suricata
1361 lfsmake2 oinkmaster
1362 lfsmake2 ids-ruleset-sources
1363 lfsmake2 squid
1364 lfsmake2 squidguard
1365 lfsmake2 calamaris
1366 lfsmake2 tcpdump
1367 lfsmake2 traceroute
1368 lfsmake2 vlan
1369 lfsmake2 wireless
1370 lfsmake2 pakfire
1371 lfsmake2 spandsp
1372 lfsmake2 lz4
1373 lfsmake2 lzo
1374 lfsmake2 openvpn
1375 lfsmake2 mpage
1376 lfsmake2 dbus
1377 lfsmake2 intltool
1378 lfsmake2 libdaemon
1379 lfsmake2 avahi
1380 lfsmake2 cups
1381 lfsmake2 lcms2
1382 lfsmake2 ghostscript
1383 lfsmake2 qpdf
1384 lfsmake2 poppler
1385 lfsmake2 cups-filters
1386 lfsmake2 epson-inkjet-printer-escpr
1387 lfsmake2 foomatic
1388 lfsmake2 hplip
1389 lfsmake2 cifs-utils
1390 lfsmake2 krb5
1391 lfsmake2 samba
1392 lfsmake2 sudo
1393 lfsmake2 mc
1394 lfsmake2 wget
1395 lfsmake2 bridge-utils
1396 lfsmake2 smartmontools
1397 lfsmake2 htop
1398 lfsmake2 chkconfig
1399 lfsmake2 postfix
1400 lfsmake2 fetchmail
1401 lfsmake2 cyrus-imapd
1402 lfsmake2 clamav
1403 lfsmake2 perl-NetAddr-IP
1404 lfsmake2 spamassassin
1405 lfsmake2 perl-Net-LibIDN
1406 lfsmake2 amavisd
1407 lfsmake2 dma
1408 lfsmake2 alsa
1409 lfsmake2 mpfire
1410 lfsmake2 guardian
1411 lfsmake2 libid3tag
1412 lfsmake2 libmad
1413 lfsmake2 libogg
1414 lfsmake2 libvorbis
1415 lfsmake2 libdvbpsi
1416 lfsmake2 flac
1417 lfsmake2 lame
1418 lfsmake2 sox
1419 lfsmake2 soxr
1420 lfsmake2 libshout
1421 lfsmake2 xvid
1422 lfsmake2 libmpeg2
1423 lfsmake2 gnump3d
1424 lfsmake2 rsync
1425 lfsmake2 libtirpc
1426 lfsmake2 rpcbind
1427 lfsmake2 keyutils
1428 lfsmake2 nfs
1429 lfsmake2 gnu-netcat
1430 lfsmake2 ncat
1431 lfsmake2 nmap
1432 lfsmake2 etherwake
1433 lfsmake2 bwm-ng
1434 lfsmake2 sysstat
1435 lfsmake2 strongswan
1436 lfsmake2 rng-tools
1437 lfsmake2 lsof
1438 lfsmake2 br2684ctl
1439 lfsmake2 pcmciautils
1440 lfsmake2 lm_sensors
1441 lfsmake2 liboping
1442 lfsmake2 collectd
1443 lfsmake2 elinks
1444 lfsmake2 igmpproxy
1445 lfsmake2 fbset
1446 lfsmake2 opus
1447 lfsmake2 python-six
1448 lfsmake2 python-pyparsing
1449 lfsmake2 spice-protocol
1450 lfsmake2 spice
1451 lfsmake2 sdl
1452 lfsmake2 libusbredir
1453 lfsmake2 libseccomp
1454 lfsmake2 qemu
1455 lfsmake2 sane
1456 lfsmake2 netpbm
1457 lfsmake2 netsnmpd
1458 lfsmake2 nagios_nrpe
1459 lfsmake2 nagios-plugins
1460 lfsmake2 icinga
1461 lfsmake2 observium-agent
1462 lfsmake2 ebtables
1463 lfsmake2 directfb
1464 lfsmake2 faad2
1465 lfsmake2 alac
1466 lfsmake2 ffmpeg
1467 lfsmake2 vdr
1468 lfsmake2 vdr_streamdev
1469 lfsmake2 vdr_epgsearch
1470 lfsmake2 vdr_dvbapi
1471 lfsmake2 vdr_eepg
1472 lfsmake2 w_scan
1473 lfsmake2 icecast
1474 lfsmake2 icegenerator
1475 lfsmake2 mpd
1476 lfsmake2 libmpdclient
1477 lfsmake2 mpc
1478 lfsmake2 perl-Net-CIDR-Lite
1479 lfsmake2 perl-Net-SMTP-SSL
1480 lfsmake2 perl-MIME-Base64
1481 lfsmake2 perl-Authen-SASL
1482 lfsmake2 perl-MIME-Lite
1483 lfsmake2 perl-Email-Date-Format
1484 lfsmake2 git
1485 lfsmake2 squidclamav
1486 lfsmake2 vnstat
1487 lfsmake2 iw
1488 lfsmake2 wpa_supplicant
1489 lfsmake2 hostapd
1490 lfsmake2 pycurl
1491 lfsmake2 urlgrabber
1492 lfsmake2 syslinux
1493 lfsmake2 tftpd
1494 lfsmake2 cpufrequtils
1495 lfsmake2 bluetooth
1496 lfsmake2 gutenprint
1497 lfsmake2 apcupsd
1498 lfsmake2 iperf
1499 lfsmake2 iperf3
1500 lfsmake2 7zip
1501 lfsmake2 lynis
1502 lfsmake2 streamripper
1503 lfsmake2 sshfs
1504 lfsmake2 taglib
1505 lfsmake2 sslh
1506 lfsmake2 perl-gettext
1507 lfsmake2 perl-Sort-Naturally
1508 lfsmake2 vdradmin
1509 lfsmake2 perl-DBI
1510 lfsmake2 perl-DBD-SQLite
1511 lfsmake2 perl-File-ReadBackwards
1512 lfsmake2 openvmtools
1513 lfsmake2 motion
1514 lfsmake2 joe
1515 lfsmake2 monit
1516 lfsmake2 nut
1517 lfsmake2 watchdog
1518 lfsmake2 libpri
1519 lfsmake2 libsrtp
1520 lfsmake2 asterisk
1521 lfsmake2 usb_modeswitch
1522 lfsmake2 usb_modeswitch_data
1523 lfsmake2 zerofree
1524 lfsmake2 minicom
1525 lfsmake2 ddrescue
1526 lfsmake2 miniupnpd
1527 lfsmake2 client175
1528 lfsmake2 powertop
1529 lfsmake2 parted
1530 lfsmake2 swig
1531 lfsmake2 u-boot
1532 lfsmake2 u-boot-kirkwood
1533 lfsmake2 u-boot-friendlyarm
1534 lfsmake2 python-typing
1535 lfsmake2 python-m2crypto
1536 lfsmake2 wireless-regdb
1537 lfsmake2 crda
1538 lfsmake2 libsolv
1539 lfsmake2 python-distutils-extra
1540 lfsmake2 python-lzma
1541 lfsmake2 python-progressbar
1542 lfsmake2 python-xattr
1543 lfsmake2 ddns
1544 lfsmake2 python3-setuptools
1545 lfsmake2 python3-setuptools-scm
1546 lfsmake2 python3-six
1547 lfsmake2 python3-dateutil
1548 lfsmake2 python3-jmespath
1549 lfsmake2 python3-colorama
1550 lfsmake2 python3-docutils
1551 lfsmake2 python3-yaml
1552 lfsmake2 python3-s3transfer
1553 lfsmake2 python3-rsa
1554 lfsmake2 python3-pyasn1
1555 lfsmake2 python3-botocore
1556 lfsmake2 python3-llfuse
1557 lfsmake2 python3-msgpack
1558 lfsmake2 aws-cli
1559 lfsmake2 transmission
1560 lfsmake2 dpfhack
1561 lfsmake2 lcd4linux
1562 lfsmake2 mtr
1563 lfsmake2 minidlna
1564 lfsmake2 acpid
1565 lfsmake2 fping
1566 lfsmake2 telnet
1567 lfsmake2 xinetd
1568 lfsmake2 gpgme
1569 lfsmake2 pygpgme
1570 lfsmake2 pakfire3
1571 lfsmake2 stress
1572 lfsmake2 libstatgrab
1573 lfsmake2 sarg
1574 lfsmake2 check_mk_agent
1575 lfsmake2 nginx
1576 lfsmake2 sendEmail
1577 lfsmake2 sysbench
1578 lfsmake2 strace
1579 lfsmake2 ltrace
1580 lfsmake2 ipfire-netboot
1581 lfsmake2 lcdproc
1582 lfsmake2 bitstream
1583 lfsmake2 multicat
1584 lfsmake2 keepalived
1585 lfsmake2 ipvsadm
1586 lfsmake2 perl-Carp-Clan
1587 lfsmake2 perl-Date-Calc
1588 lfsmake2 perl-Date-Manip
1589 lfsmake2 perl-File-Tail
1590 lfsmake2 perl-TimeDate
1591 lfsmake2 swatch
1592 lfsmake2 tor
1593 lfsmake2 arm
1594 lfsmake2 wavemon
1595 lfsmake2 iptraf-ng
1596 lfsmake2 iotop
1597 lfsmake2 stunnel
1598 lfsmake2 bacula
1599 lfsmake2 batctl
1600 lfsmake2 perl-Font-TTF
1601 lfsmake2 perl-IO-String
1602 lfsmake2 perl-PDF-API2
1603 lfsmake2 squid-accounting
1604 lfsmake2 pigz
1605 lfsmake2 tmux
1606 lfsmake2 perl-Text-CSV_XS
1607 lfsmake2 haproxy
1608 lfsmake2 ipset
1609 lfsmake2 lua
1610 lfsmake2 dnsdist
1611 lfsmake2 bird
1612 lfsmake2 frr
1613 lfsmake2 dmidecode
1614 lfsmake2 mcelog
1615 lfsmake2 rtpproxy
1616 lfsmake2 util-macros
1617 lfsmake2 libpciaccess
1618 lfsmake2 libyajl
1619 lfsmake2 libvirt
1620 lfsmake2 freeradius
1621 lfsmake2 perl-common-sense
1622 lfsmake2 perl-inotify2
1623 lfsmake2 perl-Net-IP
1624 lfsmake2 wio
1625 lfsmake2 iftop
1626 lfsmake2 mdns-repeater
1627 lfsmake2 i2c-tools
1628 lfsmake2 nss-myhostname
1629 lfsmake2 dehydrated
1630 lfsmake2 shairport-sync
1631 lfsmake2 borgbackup
1632 lfsmake2 knot
1633 lfsmake2 spectre-meltdown-checker
1634 lfsmake2 zabbix_agentd
1635 lfsmake2 flashrom
1636 lfsmake2 firmware-update
1637 lfsmake2 tshark
1638 lfsmake2 geoip-generator
1639 lfsmake2 speedtest-cli
1640 lfsmake2 rfkill
1641 lfsmake2 amazon-ssm-agent
1642 }
1643
1644 buildinstaller() {
1645 # Run installer scripts one by one
1646 LOGFILE="$BASEDIR/log/_build.installer.log"
1647 export LOGFILE
1648 lfsmake2 memtest
1649 lfsmake2 installer
1650 # use toolchain bash for chroot to strip
1651 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
1652 }
1653
1654 buildpackages() {
1655 LOGFILE="$BASEDIR/log/_build.packages.log"
1656 export LOGFILE
1657 echo "... see detailed log in _build.*.log files" >> $LOGFILE
1658
1659
1660 # Generating list of packages used
1661 print_line "Generating packages list from logs"
1662 rm -f $BASEDIR/doc/packages-list
1663 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1664 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
1665 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
1666 fi
1667 done
1668 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
1669 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
1670 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1671 rm -f $BASEDIR/doc/packages-list
1672 # packages-list.txt is ready to be displayed for wiki page
1673 print_status DONE
1674
1675 # Update changelog
1676 cd $BASEDIR
1677 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1678 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1679 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
1680
1681 # Create images for install
1682 lfsmake2 cdrom
1683
1684 # Check if there is a loop device for building in virtual environments
1685 modprobe loop 2>/dev/null
1686 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
1687 lfsmake2 flash-images
1688 fi
1689
1690 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
1691
1692 ipfirepackages
1693
1694 lfsmake2 xen-image
1695 mv $LFS/install/images/*.bz2 $BASEDIR >> $LOGFILE 2>&1
1696
1697 cd $BASEDIR
1698
1699 # remove not useable iso on armv5tel (needed to build flash images)
1700 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
1701
1702 for i in `ls *.bz2 *.img.xz *.iso`; do
1703 md5sum $i > $i.md5
1704 done
1705 cd $PWD
1706
1707 # Cleanup
1708 stdumount
1709 rm -rf $BASEDIR/build/tmp/*
1710
1711 cd $PWD
1712 }
1713
1714 ipfirepackages() {
1715 lfsmake2 core-updates
1716
1717 local i
1718 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
1719 i=$(basename ${i})
1720 if [ -e $BASEDIR/lfs/$i ]; then
1721 ipfiredist $i
1722 else
1723 echo -n $i
1724 print_status SKIP
1725 fi
1726 done
1727 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
1728 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
1729 rm -rf $BASEDIR/build/install/packages/*
1730 }
1731
1732 while [ $# -gt 0 ]; do
1733 case "${1}" in
1734 --target=*)
1735 configure_build "${1#--target=}"
1736 ;;
1737 -*)
1738 exiterror "Unknown configuration option: ${1}"
1739 ;;
1740 *)
1741 # Found a command, so exit options parsing.
1742 break
1743 ;;
1744 esac
1745 shift
1746 done
1747
1748 # See what we're supposed to do
1749 case "$1" in
1750 build)
1751 START_TIME=$(now)
1752
1753 # Clear screen
1754 ${INTERACTIVE} && clear
1755
1756 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
1757 #only restore on a clean disk
1758 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
1759 if [ ! -n "$PACKAGE" ]; then
1760 print_build_stage "Full toolchain compilation"
1761 prepareenv
1762 buildtoolchain
1763 else
1764 PACKAGENAME=${PACKAGE%.tar.xz}
1765 print_build_stage "Packaged toolchain compilation"
1766 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
1767 tar axf $PACKAGE
1768 prepareenv
1769 else
1770 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1771 fi
1772 fi
1773 else
1774 prepareenv
1775 fi
1776
1777 print_build_stage "Building LFS"
1778 buildbase
1779
1780 print_build_stage "Building IPFire"
1781 buildipfire
1782
1783 print_build_stage "Building installer"
1784 buildinstaller
1785
1786 print_build_stage "Building packages"
1787 buildpackages
1788
1789 print_build_stage "Checking Logfiles for new Files"
1790
1791 cd $BASEDIR
1792 tools/checknewlog.pl
1793 tools/checkrootfiles
1794 cd $PWD
1795
1796 print_build_summary $(( $(now) - ${START_TIME} ))
1797 ;;
1798 shell)
1799 # enter a shell inside LFS chroot
1800 # may be used to changed kernel settings
1801 prepareenv
1802 entershell
1803 ;;
1804 clean)
1805 print_line "Cleaning build directory..."
1806
1807 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1808 $LOSETUP -d $i 2>/dev/null
1809 done
1810 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1811 umount $i
1812 done
1813 stdumount
1814 for i in `seq 0 7`; do
1815 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
1816 umount /dev/loop${i} 2>/dev/null;
1817 losetup -d /dev/loop${i} 2>/dev/null;
1818 fi;
1819 done
1820 rm -rf $BASEDIR/build
1821 rm -rf $BASEDIR/cdrom
1822 rm -rf $BASEDIR/packages
1823 rm -rf $BASEDIR/log
1824 if [ -h "${TOOLS_DIR}" ]; then
1825 rm -f "${TOOLS_DIR}"
1826 fi
1827 rm -f $BASEDIR/ipfire-*
1828 print_status DONE
1829 ;;
1830 docker)
1831 # Build the docker image if it does not exist, yet
1832 if ! docker images -a | grep -q ^ipfire-builder; then
1833 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1834 print_status DONE
1835 else
1836 print_status FAIL
1837 exit 1
1838 fi
1839 fi
1840
1841 # Run the container and enter a shell
1842 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1843 ;;
1844 downloadsrc)
1845 if [ ! -d $BASEDIR/cache ]; then
1846 mkdir $BASEDIR/cache
1847 fi
1848 mkdir -p $BASEDIR/log
1849 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
1850 FINISHED=0
1851 cd $BASEDIR/lfs
1852 for c in `seq $MAX_RETRIES`; do
1853 if (( FINISHED==1 )); then
1854 break
1855 fi
1856 FINISHED=1
1857 cd $BASEDIR/lfs
1858 for i in *; do
1859 if [ -f "$i" -a "$i" != "Config" ]; then
1860 lfsmakecommoncheck ${i} || continue
1861
1862 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1863 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
1864 if [ $? -ne 0 ]; then
1865 print_status FAIL
1866 FINISHED=0
1867 else
1868 if [ $c -eq 1 ]; then
1869 print_status DONE
1870 fi
1871 fi
1872 fi
1873 done
1874 done
1875 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
1876 ERROR=0
1877 for i in *; do
1878 if [ -f "$i" -a "$i" != "Config" ]; then
1879 lfsmakecommoncheck ${i} > /dev/null || continue
1880 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1881 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
1882 if [ $? -ne 0 ]; then
1883 echo -ne "MD5 difference in lfs/$i"
1884 print_status FAIL
1885 ERROR=1
1886 fi
1887 fi
1888 done
1889 if [ $ERROR -eq 0 ]; then
1890 echo -ne "${BOLD}all files md5sum match${NORMAL}"
1891 print_status DONE
1892 else
1893 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
1894 print_status FAIL
1895 fi
1896 cd - >/dev/null 2>&1
1897 ;;
1898 toolchain)
1899 # Clear screen
1900 ${INTERACTIVE} && clear
1901
1902 prepareenv
1903 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
1904 buildtoolchain
1905 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1906 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1907 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log | xz ${XZ_OPT} \
1908 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz
1909 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
1910 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
1911 stdumount
1912 ;;
1913 gettoolchain)
1914 # arbitrary name to be updated in case of new toolchain package upload
1915 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
1916 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.xz ]; then
1917 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
1918 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1919 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1920 cd $BASEDIR/cache/toolchains
1921 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.xz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
1922 if [ $? -ne 0 ]; then
1923 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
1924 else
1925 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
1926 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1927 else
1928 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1929 fi
1930 fi
1931 else
1932 echo "Toolchain is already downloaded. Exiting..."
1933 fi
1934 ;;
1935 uploadsrc)
1936 PWD=`pwd`
1937 if [ -z $IPFIRE_USER ]; then
1938 echo -n "You have to setup IPFIRE_USER first. See .config for details."
1939 print_status FAIL
1940 exit 1
1941 fi
1942
1943 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
1944 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
1945
1946 for file in ${BASEDIR}/cache/*; do
1947 [ -d "${file}" ] && continue
1948 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
1949 NEW_FILES="$NEW_FILES $file"
1950 done
1951 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1952 cd $BASEDIR
1953 cd $PWD
1954 exit 0
1955 ;;
1956 lang)
1957 echo -ne "Checking the translations for missing or obsolete strings..."
1958 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1959 $BASEDIR/tools/sort_strings.pl en
1960 $BASEDIR/tools/sort_strings.pl de
1961 $BASEDIR/tools/sort_strings.pl fr
1962 $BASEDIR/tools/sort_strings.pl es
1963 $BASEDIR/tools/sort_strings.pl pl
1964 $BASEDIR/tools/sort_strings.pl ru
1965 $BASEDIR/tools/sort_strings.pl nl
1966 $BASEDIR/tools/sort_strings.pl tr
1967 $BASEDIR/tools/sort_strings.pl it
1968 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1969 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1970 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1971 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
1972 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.pl
1973 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1974 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1975 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1976 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1977 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
1978 print_status DONE
1979
1980 echo -ne "Updating language lists..."
1981 update_language_list ${BASEDIR}/src/installer/po
1982 update_language_list ${BASEDIR}/src/setup/po
1983 print_status DONE
1984 ;;
1985 update-contributors)
1986 update_contributors
1987 ;;
1988 *)
1989 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors}"
1990 cat doc/make.sh-usage
1991 ;;
1992 esac